/*
  In a client we store the state of the thread
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */


#include <producer/core/threadState.h>



ThreadState::ThreadState() {
  int i;
  
  freePos=0;
  readPos=0;
  fillgrade=0;

  for(i=0;i<_MAX_THREAD_ENTRIES;i++) {
    threadEntryArray[i]=new ThreadEntry();
    threadEntryArray[i]->valid=false;
  }
  pthread_mutex_init(&stateMut,NULL);
}


ThreadState::~ThreadState() {
  int i;

  for(i=0;i<_MAX_THREAD_ENTRIES;i++) {
    delete threadEntryArray[i];
  } 
}


void ThreadState::setProducerEnter(int allow) {
}


void ThreadState::enqueueThreadState(int state) {
  pthread_mutex_lock(&stateMut);

  if (fillgrade == _MAX_THREAD_ENTRIES) {
    cout << "threadState overflow! ignoring new state!"<<endl;
    pthread_mutex_unlock(&stateMut);
    return;
  }
  threadEntryArray[freePos]->state=state;
  threadEntryArray[freePos]->valid=true; 
  fillgrade++;
  freePos++;
  if (freePos == _MAX_THREAD_ENTRIES) {
    freePos=0;
  }
  pthread_mutex_unlock(&stateMut);
}


int ThreadState::hasState() {
  return (fillgrade > 0);
}


int ThreadState::dequeueThreadState() {
  
  int back;
  pthread_mutex_lock(&stateMut);

  if (threadEntryArray[readPos]->valid == true) {
    back=threadEntryArray[readPos]->state;

    readPos++;
    fillgrade--;
  }
  if (readPos == _MAX_THREAD_ENTRIES) {
    readPos=0;
  }
  pthread_mutex_unlock(&stateMut);
  return back;
  
}

