/*
  device print the time of the stream which was actually written
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */



#include <devices/infoDevice.h>



InfoDevice::InfoDevice() {
  musicInfo=new MusicInfo();
}


InfoDevice::~InfoDevice() {
  delete musicInfo;
}


char* InfoDevice::getNodeName() {
  return "InfoDevice";
}


char* InfoDevice::getName() {
  return musicInfo->getName();
}


int InfoDevice::getSec() {
  return musicInfo->getSec();
}



void InfoDevice::writeIn(NodeDevice* source,DeviceConfig* buf) {
  MusicInfo* mInfo=buf->getMusicInfo();

  if (mInfo->getChange()) {
    mInfo->setChange(false);
    mInfo->copyTo(musicInfo);
    cout << "Name:"<<musicInfo->getName()<<endl;
    cout << "Time:"<<musicInfo->getSec()<<endl;
    dataSendNotify();
    return;
  }
}


